REM
REM  FDGOPHER handler for TXT files
REM
REM  ReadTXT is expecting the following shared variables to be set:
REM    xSize....................Terminal's max columns
REM    ySize....................Terminsl's max rows
REM    FileBuffer().............Array containing the data file
REM    FileSize.................Data file's size in bytes
REM    ColorScheme.DocumentFg...Content window foreground
REM    ColorScheme.DocumentBg...Content window background
REM    ColorScheme.StatusBarFg..Status bar foreground
REM    ColorScheme.StatusBarBg..Status bar background
REM    ColorScheme.BorderFg.....Border's foreground color
REM    ColorScheme.BorderBg.....Border's background color
REM
#INCLUDE ONCE "wordwrap.bi"
#INCLUDE ONCE "vbcompat.bi"

SUB ReadTxt()
  DIM AS STRING LineBuff, LastKey, WrappedLine
  DIM AS UBYTE CharBuff
  DIM AS INTEGER FileCursor, ScreenBufferLines, MaxLineLen, FirstLine = 1, x, MaxLineCount, CursorPosition
  REDIM ScreenBuffer(1 TO 32) AS STRING
  MaxLineLen = xSize - 2
  MaxLineCount = ySize - 3
  WHILE FileCursor < FileSize
    DO
      FileCursor += 1
      CharBuff = FileBuffer(FileCursor)
      IF CharBuff >= 32 THEN LineBuff += CHR(CharBuff)  ' Ignore control codes
      IF CharBuff = 9 THEN LineBuff += SPACE(8)      ' Replace any TAB by 8 spaces
    LOOP UNTIL FileCursor >= FileSize OR CharBuff = 10
    IF NOT (LineBuff = "." AND FileSize - FileCursor < 3) THEN
      DO
        WrappedLine = WordWrap(LineBuff, MaxLineLen)
        IF ScreenBufferLines = UBOUND(ScreenBuffer) THEN REDIM PRESERVE ScreenBuffer(1 TO ScreenBufferLines * 2) AS STRING
        ScreenBufferLines += 1
        ScreenBuffer(ScreenBufferLines) = WrappedLine
      LOOP UNTIL LineBuff = ""
    END IF
    LineBuff = ""
  WEND
  COLOR ColorScheme.StatusBarFg, ColorScheme.StatusBarBg
  LOCATE ySize, 1 : PRINT SPACE(xSize);
  LOCATE ySize, 1 : PRINT " Keys: Up/Down, PgUp/PgDown, BackSpc, TAB";

  DO
    COLOR ColorScheme.DocumentFg, ColorScheme.DocumentBg
    FOR x = 1 TO MaxLineCount
      IF FirstLine + x - 1 <= ScreenBufferLines THEN LineBuff = ScreenBuffer(FirstLine + x - 1) ELSE LineBuff = ""
      LOCATE 2 + x, 2: PRINT LineBuff + SPACE(MaxLineLen - LEN(LineBuff));
    NEXT x
    IF ScreenBufferLines > MaxLineCount THEN    ' Refresh the scrollbar
      COLOR ColorScheme.BorderFg, ColorScheme.BorderBg
      CursorPosition = INT((FirstLine - 1) / (ScreenBufferLines - MaxLineCount) * (MaxLineCount - 3))
      LOCATE 3, xSize : PRINT SymbolChar(1);
      LOCATE ySize - 1, xSize : PRINT SymbolChar(3);
      FOR x = 4 TO ySize - 2
        LOCATE x, xSize : PRINT SymbolChar(2);
      NEXT x
      COLOR ColorScheme.BorderBg, ColorScheme.BorderFg
      LOCATE 4 + CursorPosition, xSize : PRINT " ";
    END IF
    LOCATE ySize, xSize, 0   ' Hide the annoying blinking cursor
    RefreshScreen()          ' Update the screen's content
    KeybFlush()              ' Flush keyb buffer
    SLEEP
    LastKey = INKEY
    IF LastKey = CHR(255) + "H" THEN FirstLine -= 1                                   ' Up
    IF LastKey = CHR(255) + "P" THEN FirstLine += 1                                   ' Down
    IF LastKey = CHR(255) + "I" THEN FirstLine -= MaxLineCount                        ' PgUp
    IF LastKey = CHR(255) + "Q" THEN FirstLine += MaxLineCount                        ' PgDown
    IF LastKey = CHR(255) + "G" THEN FirstLine = 1                                    ' Home
    IF LastKey = CHR(255) + "O" THEN FirstLine = ScreenBufferLines - MaxLineCount + 1 ' End
    IF FirstLine + MaxLineCount - 1 > ScreenBufferLines THEN FirstLine = ScreenBufferLines - MaxLineCount + 1
    IF FirstLine > 1 AND ScreenBufferLines <= MaxLineCount THEN FirstLine = 1
    IF FirstLine < 1 THEN FirstLine = 1
    IF LastKey = CHR(27) THEN QuitProgram()
    IF LastKey = CHR(8) THEN HistoryBack()
    IF LastKey = CHR(9) THEN NewURL = TypeNewURL(CurURL)
  LOOP UNTIL LastKey = CHR(8) OR LastKey = CHR(9)
END SUB
